#include "client.h"
#include "graphic.h"

#define TRESOR 4

#define NTHREAD 4

int parcours[LARGEUR * HAUTEUR];
int valeur_capteur[8][VISION];
int position, direction;

// Exclusion mutuelle
pthread_mutex_t wrlock ;
pthread_cond_t wrok;
sem_t barriere;

int wrstop = 0;

// Pour le rseau
int sock;

int manger = 0;


// direction = position present - position precedente

/**************************** CAPTEUR *********************************/
void *capteur (void * arg)
{
  int i;
  int type;
  
  type = (int) arg;

  
  
  DEBUG(stderr, "thread de type %d cree\n", type); 
  
  while (1) {
    // pour avoir une attente, specifique a un capteur

    DEBUG(stderr,"In thread %d\n", type);

    pthread_mutex_lock(&wrlock);
    while(wrstop) {
      sem_post(&barriere);
      pthread_cond_wait(&wrok, &wrlock);
    }

    switch (type) {
    default:
    when AvGa : 
      switch (direction) {
      default:
      when NoOu : 
     	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Ou, i+1);
	
      when No : 	 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, NoOu, i+1);
	 
      when NoEs:
	for (i = 0; i < VISION; i++)
	  valeur_capteur[type][i] = parcour(type, position, No, i+1);

      when Es : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, NoEs, i+1);
	
      when SuEs : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Es, i+1);
	
      when Su : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, SuEs, i+1);
	      
      when SuOu : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Su, i+1);
            
      when Ou : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, SuOu, i+1);
      }
    
    when  Av : 
      switch (direction) {
      default:
      when NoOu : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, NoOu, i+1);
	
      when No : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, No, i+1);
      
      when NoEs: 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, NoEs, i+1);
      
      when Es : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Es, i+1);
      
      when SuEs : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, SuEs, i+1);
	
      
      when Su : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Su, i+1);

      when SuOu : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, SuOu, i+1);

      when Ou : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Ou, i+1);
      }

    when AvDr : 
      switch (direction) {
      default:
      when NoOu : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, No, i+1);
	 
      when No : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, NoEs, i+1);
	
      when NoEs: 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Es, i+1);
	      
      when Es : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, SuEs, i+1);
	
      
      when SuEs : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Su, i+1);
            
      when Su : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, SuOu, i+1);
	      
      when SuOu : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Ou, i+1);
	      
      when Ou : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, NoOu, i+1);
      }

    when Dr : 
      switch (direction) {
      default:
      when NoOu : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, NoEs, i+1);
	
      when No : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Es, i+1);
      
      when NoEs: 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, SuEs, i+1);
	
      when Es : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Su, i+1);
      
      when SuEs : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, SuOu, i+1);
      
      when Su : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Ou, i+1);
      
      when SuOu : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, NoOu, i+1);
      
      when Ou : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, No, i+1);
    }

    when ArDr : 
      switch (direction) {
      default:
      when NoOu : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Es, i+1);
      
      when No : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, SuEs, i+1);
	
      when NoEs: 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Su, i+1);
      
      when Es : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, SuOu, i+1);
      
      when SuEs : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Ou, i+1);
      
      when Su : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, NoOu, i+1);
      
      when SuOu : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, No, i+1);
      
      when Ou : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, NoEs, i+1);
      }

    when Ar : 
      switch (direction) {
      default:
      when NoOu : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, SuEs, i+1);
	
      when No : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Su, i+1);
      
      when NoEs: 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, SuOu, i+1);
      
      when Es : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Ou, i+1);
	     
      when SuEs : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, NoOu, i+1);
      
      when Su : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, No, i+1);
      
      when SuOu : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, NoEs, i+1);
      
      when Ou : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Es, i+1);
      }
    
    when ArGa : 
      switch (direction) {
      default:
      when NoOu : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Su, i+1);
	
      when No : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, SuOu, i+1);
	
      when NoEs: 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Ou, i+1);
      
      when Es : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, NoOu, i+1);
	
      when SuEs : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, No, i+1);
      
      when Su : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, NoEs, i+1);
      
      when SuOu : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Es, i+1);
      
      when Ou : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, SuEs, i+1);
    }

    when Ga : 
      switch (direction) {
      default:
      when NoOu : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, SuOu, i+1);
      
      when No : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Ou, i+1);
	
      when NoEs: 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, NoOu, i+1);
      
      when Es : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, No, i+1);
      
      when SuEs : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, NoEs, i+1);
      
      when Su : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Es, i+1);
      
      when SuOu : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, SuEs, i+1);
      
      when Ou : 
	for (i = 0; i < VISION; i++) 
	  valeur_capteur[type][i] = parcour(type, position, Su, i+1);
      }
    }

    pthread_mutex_unlock(&wrlock);
    usleep(500);
  }
  
  pthread_exit (0);
}

int deplace (int var)
{
  
  switch (var) {
  case AvGa : {
    switch (direction) {
    case NoOu : {
      return( Ou );
    }
    case No : {
      return( NoOu );
    }
    case NoEs: {
      return( No );
    }
    case Es : {
      return( NoEs );
    }
    case SuEs : {
      return( Es );
    }
    case Su : {
      return( SuEs );
    }
    case SuOu : {
      return( Su );
    }
    case Ou : {
      return( SuOu );
    }
    }
  }
  case  Av : {
    switch (direction) {
    case NoOu : {
      return( NoOu );
    }
    case No : {
      return( No );
    }
    case NoEs: {
      return( NoEs );
    }
    case Es : {
      return( Es );
    }
    case SuEs : {
      return( SuEs );
    }
    case Su : {
      return( Su );
    }
    case SuOu : {
      return( SuOu );
    }
    case Ou : {
      return( Ou );
    }
    }
  }
  case AvDr : {
    switch (direction) {
    case NoOu : {
      return( No );
    }
    case No : {
      return( NoEs );
    }
    case NoEs: {
      return( Es );
    }
    case Es : {
      return( SuEs );
    }
    case SuEs : {
      return( Su );
    }
    case Su : {
      return( SuOu );
    }
    case SuOu : {
      return( Ou );
    }
    case Ou : {
      return( NoOu );
    }
    }
  }
  case Dr : {
    switch (direction) {
    case NoOu : {
      return( NoEs );
    }
    case No : {
      return( Es );
    }
    case NoEs: {
      return( SuEs );
    }
    case Es : {
      return( Su );
    }
    case SuEs : {
      return( SuOu );
    }
    case Su : {
      return( Ou );
    }
    case SuOu : {
      return( NoOu );
    }
    case Ou : {
      return( No );
    }
    }
  }
  case ArDr : {
    switch (direction) {
    case NoOu : {
      return( Es );
    }
    case No : {
      return( SuEs );
    }
    case NoEs: {
      return( Su );
    }
    case Es : {
      return( SuOu );
    }
    case SuEs : {
      return( Ou );
    }
    case Su : {
      return( NoOu );
    }
    case SuOu : {
      return( No );
    }
    case Ou : {
      return( NoEs );
    }
    }
  }
  case Ar : {
    switch (direction) {
    case NoOu : {
      return( SuEs );
    }
    case No : {
      return( Su );
    }
    case NoEs: {
      return( SuOu );
    }
    case Es : {
      return( Ou );
    }
    case SuEs : {
      return( NoOu );
    }
    case Su : {
      return( No );
    }
    case SuOu : {
      return( NoEs );
    }
    case Ou : {
      return( Es );
    }
    }
  }
  case ArGa : {
    switch (direction) {
    case NoOu : {
      return( Su );
    }
    case No : {
      return( SuOu );
    }
    case NoEs: {
      return( Ou );
    }
    case Es : {
      return( NoOu );
    }
    case SuEs : {
      return( No );
    }
    case Su : {
      return( NoEs );
    }
    case SuOu : {
      return( Es );
    }
    case Ou : {
      return( SuEs );
    }
    }
  }
  case Ga : {
    switch (direction) {
    case NoOu : {
      return( SuOu );
    }
    case No : {
      return( Ou );
    }
    case NoEs: {
      return( NoOu );
    }
    case Es : {
      return( No );
    }
    case SuEs : {
      return( NoEs );
    }
    case Su : {
      return( Es );
    }
    case SuOu : {
      return( SuEs );
    }
    case Ou : {
      return( Su );
    }
    }
  }
  }
  return 0;
}


/**************************** Valeur des capteurs ***********************/

int parcour(int which, int pos, int dir, int val) {

  /*
  char temp;

  temp = (pos + dir);

  DEBUG(stderr, "In parcours (pos = %d, dir = %d)\n", pos, dir);

  write(sock, READ, sizeof(READ));
  write(sock, &temp, sizeof temp );

  read(sock, &temp, sizeof temp );

  DEBUG(stderr, "In parcours (temp = %d)\n", temp);
 
  return temp;
  */


  if (dir == No) {
    if ((pos / LARGEUR) < val) {
      return -1;
    }
    else {
      return(recupere(which, pos + (dir * val)));
    }
  }
  else if (dir == Su) {
    if ((pos / LARGEUR) >= (HAUTEUR - val)) {
      return -1;
    }
    else {
      return(recupere(which,pos + (dir * val)));
    }
  }
  else if (dir == Ou) {
    if ((pos % LARGEUR) < val) {
      return -1;
    }
    else {
      return(recupere(which,pos + (dir * val)));
    }
  }
  else if (dir == Es) {
    if ((pos % LARGEUR) >= (LARGEUR - val)) {
      return -1;
    }
    else {
      return(recupere(which,pos + (dir * val)));
    }

  }
  else if (dir == NoOu) {
    if (((pos / LARGEUR)  < val) || ((pos % LARGEUR) < val)) {
      return -1;
    }
    else {
      return(recupere(which,pos + (dir * val)));
    }

  }
  else if (dir == NoEs) {
    if (((pos / LARGEUR) < val) || ((pos % LARGEUR) >= (LARGEUR - val))) {
      return -1;
    }
    else {
      return(recupere(which,pos + (dir * val)));
    }

  }
  else if (dir == SuOu) {
    if (((pos / LARGEUR) >= (HAUTEUR - val)) || ((pos % LARGEUR) < val)) {
      return -1;
    }
    else {
      return(recupere(which,pos + (dir * val)));
    }

  }
  else if (dir == SuEs) {
    if (((pos / LARGEUR) >= (HAUTEUR - val)) || ((pos % LARGEUR) >= (LARGEUR - val))) {
      return -1;
    }
    else {
      return(recupere(which,pos + (dir * val)));
    }
    
  }
  return 0;

}

/***************************** FONCTION RESAU **************************/

int recupere (int which, int lequel) {
  char temp;

  temp = lequel;

  DEBUG(stderr, "In recup (which = %d, lequel = %d)\n", which, lequel);

  write(sock, READ, sizeof(READ));
  DEBUG(stderr,"In Recup wrote READ (which = %d)\n", which);
  usleep(500);

  write(sock, &temp, sizeof temp);
  DEBUG(stderr,"In Recup wrote temp(%d) (which = %d)\n", temp, which);
  usleep(500);

  read(sock, &temp, sizeof temp); 
  DEBUG(stderr, "In recup recv (which = %d, temp = %d)\n", which, temp);

  return temp;
}


void envoi (char lequel) {
  char temp;

  temp = lequel;

  DEBUG(stderr, "In envoi (lequel = %d)\n", lequel);

  write(sock, WRITE, sizeof WRITE);
  usleep(500);
  write(sock, &temp, sizeof temp);
  usleep(700000);
}

  

/********************* LE MAIN **************************/

int main(int argc,char *argv[]) {

  int cap_avt, cap_arr, cap_d, cap_g;
  
  //  char tempo[1];

  int i;
  //  char buf[256];

  // Pour les threads
  pthread_t th[8];
  void *ret;

  //Pour le reseau
  struct sockaddr_in server;
  struct hostent *server_data;

  //Initialisation des threads
  pthread_mutex_init(&wrlock, NULL);
  pthread_cond_init(&wrok, NULL);
  sem_init(&barriere, 0, 0);


  // Connexion a la machine
  if((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0){
    perror("socket() call");
    exit(1);
  }
  
  server.sin_family = AF_INET;  
  
  if((server_data = gethostbyname(argv[1]))==0){
    fprintf(stderr, "%s: hote inconnu",argv[1]);
    exit(1);
  }
  memcpy(&server.sin_addr, server_data->h_addr,  server_data->h_length);
  server.sin_port = htons(PORT);
  
  if(connect(sock,(struct sockaddr *)&server,sizeof server)  < 0){
    perror("Pas de connexion: connect()");
    exit(1);
  }

  //  if(write(sock, CONNECT, sizeof CONNECT) < 0)
  //  perror("Pas de transmission: write()");
  
  //  read(sock, tempo, sizeof(tempo[0]));
  position = 1;
  printf("La position est : %d\n", position);


  direction = Su;
  DEBUG(stderr, "In main 772 (dir = %d)\n", direction);


  // Creation des threads
  /*
  for (i=0; i<8; i++) {
    if (pthread_create (&th[i], NULL, capteur,(void *) i) < 0) {
      fprintf (stderr, "Erreur de creation du thread numero %d\n", i);
      exit (1);
    }
  }
  */

  pthread_create (&th[Av], NULL, capteur,(void *) Av);
  pthread_create (&th[Dr], NULL, capteur,(void *) Dr);
  pthread_create (&th[Ar], NULL, capteur,(void *) Ar);
  pthread_create (&th[Ga], NULL, capteur,(void *) Ga);

  usleep(5000);

  // La boucle principale
  while(1){
    pthread_mutex_lock(&wrlock);
    wrstop = 1;
    pthread_mutex_unlock(&wrlock);

    for (i = 0; i < NTHREAD; i++) {
      while(sem_wait(&barriere) != 0)
	;
    }

    /*
    cap_avt = recupere(0, position + deplace(Av));
    cap_arr = recupere(0, position + deplace(Ar));
    cap_d   = recupere(0, position + deplace(Dr));
    cap_g   = recupere(0, position + deplace(Ga));
    */

    
    cap_avt = valeur_capteur[Av][0];
    cap_arr = valeur_capteur[Ar][0];
    cap_d   = valeur_capteur[Dr][0];
    cap_g   = valeur_capteur[Ga][0];
    
    fprintf(stderr, "In main 814 : capteur av:%d, ar:%d, dr:%d, ga:%d\n",
	   cap_avt, cap_arr, cap_d, cap_g);


    if (manger == 0) {
      /*
      if (cap_avt == '0')
	;
      else if (cap_g == '0')
	direction = deplace(Ga);
      else if (cap_d == '0')
	direction = deplace(Dr);
      else 
	direction = deplace(Ar);
      */
      if (cap_g == '0')
	direction = deplace(Ga);
      else if (cap_avt == '0')
	direction = deplace(Av);
      else if (cap_d == '0')
	direction = deplace(Dr);
      else 
	direction = deplace(Ar);
    }
    else {
      //on cherche la sortie

    }
    
    
    DEBUG(stderr, "In main 841 (dir = %d)\n", direction);
 
    position += direction;

    // puis on ecrit la position et on lit les informations complementaire
    envoi(position);

    wrstop = 0;
    pthread_cond_broadcast(&wrok);


    usleep(2000);
  }
  
  // Fermeture des threads
  for (i=0; i<8; i++) {
    (void)pthread_join (th[i], &ret);
  }

  // On se barre
  close(sock);
  exit(0);
}
