#include "graphic.h"

static FL_PUP_ENTRY Choices_Game_Menu[] =
{
  {"Start Game", 0, "", FL_PUP_NONE },
  {"Load Map"  , 0, "", FL_PUP_NONE },
  {"Quit"      , 0, "", FL_PUP_NONE },
  { 0 }
};

static FL_PUP_ENTRY Choices_Options_Menu[] =
{
  {"Labyrinth", 0, "", FL_PUP_NONE },
  {"Robot"    , 0, "", FL_PUP_NONE },
  {"Network"  , 0, "", FL_PUP_NONE },
  { 0 }
};

static FL_PUP_ENTRY Choices_About_Menu[] =
{
  { "Info", 0, "", FL_PUP_NONE },
  { 0 }
};

FD_LOADER * 
create_form_loader(void) {
  
  FL_OBJECT * obj;
  FD_LOADER * Loader = (FD_LOADER *) fl_calloc(1, sizeof(FD_LOADER));
  
  Loader->loader = fl_bgn_form(FL_FRAME_BOX,411,183);

  Loader->Texture_pixmap = obj =fl_add_pixmap(FL_NORMAL_PIXMAP, 2, 2, 409, 181, ""); {
    fl_set_pixmap_file(obj, LOAD_PIXMAP);
    fl_set_object_lcol(obj, FL_BLACK);
    fl_set_object_lsize(obj, FL_NORMAL_SIZE);
    fl_set_object_lalign(obj, FL_ALIGN_LEFT_BOTTOM|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj, FL_BOLD_STYLE);
  }

  fl_end_form();
  
  Loader->loader->fdui = Loader;

  return Loader;
}

FD_MAIN * 
create_form_main(void) {
  
  Pixmap p, mask;
  unsigned w,h;

  FL_OBJECT * obj;
  FD_MAIN   * Main = (FD_MAIN *) fl_calloc(1, sizeof(FD_MAIN));

  int init_x = 20;
  int init_y = 55;

  int init_x_mem = 455;
  int init_y_mem = 95;

  int ligne, colonne;

  /* dfinition de la forme principale */
  p = fl_read_pixmapfile(fl_root, ICON_PIXMAP, &w, &h, &mask, 0, 0, 0);
  Main->main = fl_bgn_form(FL_NO_BOX, 740, 480);
  fl_set_form_icon(Main->main, p, mask);
  fl_set_app_mainform(Main->main);
  fl_set_form_dblbuffer(Main->main, 1);

  obj = fl_add_box(FL_UP_BOX, 0, 0, 740, 35, "");
  obj = fl_add_box(FL_EMBOSSED_BOX, 0, 35, 740, 445, "");

  // menu principal
  Main->Game_Menu = obj = menu_button(5, 5, 85, 25, FL_PULLDOWN_MENU, "Game"); {
    fl_set_object_shortcut(obj, "^G", 0); // raccourci <cntrl>-q 
    fl_set_menu_entries(obj, Choices_Game_Menu);
    fl_set_object_callback(obj, Game_Menu_callback, 0);
  }
  Main->Options_Menu = obj = menu_button(95, 5, 85, 25, FL_PULLDOWN_MENU, "Options"); {
    fl_set_object_shortcut(obj, "^O", 0); // raccourci <cntrl>-o
    fl_set_menu_entries(obj, Choices_Options_Menu);
    fl_set_object_callback(obj, Options_Menu_callback, 0);
  }
  Main->About_Menu = obj = menu_button(185, 5, 85, 25, FL_PULLDOWN_MENU, "About"); {
    fl_set_object_shortcut(obj, "^A", 0); // raccourci <cntrl>-a
    fl_set_menu_entries(obj, Choices_About_Menu);
    fl_set_object_callback(obj, About_Menu_callback, 0);
  }
  
  // horloge systme
  Main->Clock = obj = fl_add_clock(FL_DIGITAL_CLOCK, 645, 5, 90, 25, ""); {
    fl_set_object_boxtype(obj, FL_DOWN_BOX); 
    fl_set_object_color(obj,FL_COL1, FL_BLACK);
    fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj, FL_BOLD_STYLE);
  }
  
  // boutons fentre principale 
  Main->Start_button = obj = pixmap_button(445, 435, 85, 25, FL_NO_BOX, 
					   "Start", START_BUTTON); {
    set_tip(obj, "Let's Go");
    fl_set_object_prehandler(Main->Start_button, preemptive_handler);
    fl_set_object_callback(obj, Start_callback, 0);
  }
  Main->Reset_button = obj = pixmap_button(540, 435, 85, 25, FL_NO_BOX,
					   "Reset", RESET_BUTTON); {
    set_tip(obj, "Reset Quest");
    fl_set_object_prehandler(Main->Reset_button, preemptive_handler);
    fl_set_object_callback(obj, Reset_callback, 0);
  } 
  Main->Quit_button = obj = pixmap_button(635, 435, 85, 25, FL_NO_BOX, 
					  "Quit", QUIT_BUTTON); {
    set_tip(obj, "Quit Minautor");
    fl_set_object_prehandler(Main->Quit_button, preemptive_handler);
    fl_set_object_callback(obj, Quit_callback, 0);
  }
  
  // fentre de la map  explorer
  Main->Draw_map = obj = fl_add_frame(FL_DOWN_FRAME, 20, 55, 400, 400, ""); {
    fl_set_object_gravity(obj, FL_NorthWest, FL_SouthEast);
  }
  
  // initialisation des cases map
  for(ligne = 0; ligne < NB_LIG; ligne++, init_y += GRID_DY)
    for(colonne = 0, init_x = 20; colonne < NB_COL; colonne++, init_x += GRID_DX){
      Main->Carre[colonne+(ligne*NB_COL)] = obj = fl_add_pixmap(FL_NORMAL_PIXMAP, init_x, init_y, GRID_DX, GRID_DY, ""); 
      fl_set_pixmap_file(obj, FLOOR_PIXMAP);
    }
  
  // bouton du joystick
  fl_bgn_group();
  obj = fl_add_button(FL_RADIO_BUTTON,570,350,25,25,"@#8->");
        fl_set_object_shortcut(obj, "<&A>", 0); // raccourci flche up
        fl_set_object_lcol(obj,FL_BLUE);
        fl_set_object_callback(obj,move_top_cb, 0);
  obj = fl_add_button(FL_RADIO_BUTTON,595,375,25,25,"@#->");
        fl_set_object_shortcut(obj, "<&C>", 0); // raccourci flche right
        fl_set_object_lcol(obj,FL_BLUE);
        fl_set_object_callback(obj,move_right_cb, 0);
  obj = fl_add_button(FL_RADIO_BUTTON,545,375,25,25,"@#<-");
        fl_set_object_shortcut(obj, "<&D>", 0); // raccourci flche left
        fl_set_object_lcol(obj,FL_BLUE);
        fl_set_object_callback(obj,move_left_cb, 0);
  obj = fl_add_button(FL_RADIO_BUTTON,570,400,25,25,"@#2->");
        fl_set_object_shortcut(obj, "<&B>", 0); // raccourci flche down
        fl_set_object_lcol(obj,FL_BLUE);
        fl_set_object_callback(obj,move_bottom_cb, 0);
  fl_end_group();

  // titre au dessus de la map mmoire
  obj = fl_add_box(FL_UP_BOX, 455, 55, 240, 35, "Reprsentation Map Mmoire"); {
    fl_set_object_lsize(obj, FL_NORMAL_SIZE);   // redimensionne le label
    fl_set_object_lstyle(obj, FL_BOLD_STYLE);   // label en gras
  }
  
  // fentre de la map mmoire
  Main->Draw_memory = obj = fl_add_frame(FL_EMBOSSED_FRAME, 455, 95, 240, 240, ""); {
    fl_set_object_gravity(obj, FL_NorthWest, FL_SouthEast);
  }

  // initialisation des cases mmoires
  for(ligne = 0; ligne < NB_LIG; ligne++, init_y_mem += MEM_DY)
    for(colonne = 0, init_x_mem = 455; colonne < NB_COL; colonne++, init_x_mem += MEM_DX){
      Main->Mem[colonne+(ligne*NB_COL)] = obj = fl_add_pixmap(FL_NORMAL_PIXMAP, init_x_mem, init_y_mem, MEM_DX, MEM_DY, ""); 
      fl_set_pixmap_file(obj, NULL_PIXMAP);
    }

  // initialisation de la fonction de rafraichissement de l'ecran
  //Main->ldata = fl_add_timeout(DELAY, Timeout_callback, Main);
  
  fl_end_form();
  
  Main->main->fdui = Main;

  return Main;
}

/*FD_PARAM * 
  create_form_param(void) {
  
  FL_OBJECT * obj;
  FD_PARAM   * Param = (FD_PARAM *) fl_calloc(1, sizeof(Param));
  
  Param->param->fdui = Param;
  
  return Param;
  }*/

FD_BROWSER * 
create_form_browser(void) {
  FL_OBJECT *obj;
  FD_BROWSER *Browser = (FD_BROWSER *) fl_calloc(1, sizeof(FD_BROWSER));
  
  Browser->browser = fl_bgn_form(FL_UP_BOX, 325, 120);
  
  Browser->Load_button = obj = pixmap_button(30, 70, 85, 25, FL_NO_BOX, 
					     "Load", LOAD_BUTTON); {
    fl_set_object_prehandler(Browser->Load_button, preemptive_handler);
    fl_set_object_callback(obj,Load_Browser_callback,0);
  }
  Browser->Browse_button = obj = pixmap_button(120, 70, 85, 25, FL_NO_BOX, 
					       "Browse...", BROWSE_BUTTON); {
    fl_set_object_prehandler(Browser->Browse_button, preemptive_handler);
    fl_set_object_callback(obj,Browse_Browser_callback,0);
  }
  Browser->Exit_button = obj = pixmap_button(210, 70, 85, 25, FL_NO_BOX,
					     "Exit", EXIT_BUTTON); {
    fl_set_object_prehandler(Browser->Exit_button, preemptive_handler);
    fl_set_object_callback(obj,Exit_Browser_callback,0);
  }
  
  Browser->Input_map = obj = fl_add_input(FL_NORMAL_INPUT,110,20,180,30,"Map to Load"); {
    fl_set_object_lsize(obj, FL_NORMAL_SIZE);   // redimensionne le label
    fl_set_object_lstyle(obj, FL_BOLD_STYLE);   // label en gras
  }

  fl_end_form();
  
  Browser->browser->fdui = Browser;
  
  return Browser;
}

FD_QUIT * 
create_form_quit(void) {
  
  FL_OBJECT * obj;
  FD_QUIT   * Quit = (FD_QUIT *) fl_calloc(1, sizeof(FD_QUIT));
  
  Quit->quit = fl_bgn_form(FL_UP_BOX,325,120);
  
  Quit->Question_text = obj = fl_add_box(FL_NO_BOX,160,40,0,0,"Do you want to Quit?"); {
    fl_set_object_lsize(obj, FL_NORMAL_SIZE);   // redimensionne le label
    fl_set_object_lstyle(obj, FL_BOLD_STYLE);   // label en gras
  }
  Quit->Yes_button = obj = pixmap_button(40, 70, 85, 25, FL_NO_BOX, 
					 "Yes", YES_BUTTON); {
    fl_set_object_prehandler(Quit->Yes_button, preemptive_handler);
    fl_set_object_callback(obj, Quit_Yes_callback, 0);
  }
  Quit->No_button  = obj = pixmap_button(200, 70, 85, 25, FL_NO_BOX,
					 "No", NO_BUTTON); {
    fl_set_object_prehandler(Quit->No_button, preemptive_handler);
    fl_set_object_callback(obj, Quit_No_callback, 0);
  }
  
  fl_end_form();
  
  Quit->quit->fdui = Quit;

  return Quit;
}

FD_ABOUT * create_form_about(void)
{
  FL_OBJECT *obj;
  FD_ABOUT *About = (FD_ABOUT *) fl_calloc(1, sizeof(FD_ABOUT));
  
  char *label0= 
    "The Paris 8 University\n"
    "DESS ISA\n"
    "Minotaur Project";
  
  char *label1= 
    "Ghalleb KHELIDJ\n"
    "ghalleb@ghalleb.com";
  
  char *label2=
    "Jean-Luc COSSI\n"
    "cossi@mime.up8.edu";
  
  char *label3=
    "Samir GANA\n"
    "versace@mime.up8.edu";
  
  char *label4=
    "Laurent BENCHADI\n"
    "droopy@mime.up8.edu";
  
  About->about = fl_bgn_form(FL_UP_BOX, 325, 240);

  About->Label_show = obj = fl_add_box(FL_EMBOSSED_BOX, 160, 40, 150, 110, ""); {
    fl_set_object_color(obj,FL_COL1,FL_COL1);
    fl_set_object_lstyle(obj, FL_BOLD_STYLE);   // label en gras
  }
  About->Bot_pixmap = obj = fl_add_pixmap(FL_NORMAL_PIXMAP, 20, 40, 100, 110, "");
  fl_set_pixmap_file(About->Bot_pixmap, "images/Treasure.xpm");
  
  About->Ok_button = obj = pixmap_button(120, 190, 85, 25, FL_NO_BOX,
					 "Next", OK_BUTTON); {
    fl_set_object_lcol(obj, FL_BLACK);          // couleur fond pour label
    set_tip(obj, "Next Comment");
    fl_set_object_prehandler(About->Ok_button, preemptive_handler);
  }
  
  fl_end_form();
  
  fl_set_object_label(About->Label_show, label0);
  fl_set_form_hotobject(About->about, About->Ok_button);
  fl_show_form(About->about, FL_PLACE_CENTER, FL_TRANSIENT, "About Project");
  
  // affichage des commentaires
  fl_do_forms();
  
  fl_set_object_label(About->Label_show, label1);
  fl_set_pixmap_file(About->Bot_pixmap, "images/Bot1_Pixmap.xpm");
  fl_do_forms();
  fl_set_object_label(About->Label_show, label2);
  fl_set_pixmap_file(About->Bot_pixmap, "images/Bot2_Pixmap.xpm");
  fl_do_forms();
  fl_set_object_label(About->Label_show, label3);
  fl_set_pixmap_file(About->Bot_pixmap, "images/Bot3_Pixmap.xpm");
  fl_do_forms();
  fl_set_object_label(About->Label_show, label4);
  fl_set_pixmap_file(About->Bot_pixmap, "images/Bot4_Pixmap.xpm");
  
  // reprise en main de la fentre
  fl_set_object_label(About->Ok_button, "OK");
  set_tip(obj, "Return to Minautor");
  fl_set_object_callback(obj, About_Ok_callback, 0);

  About->about->fdui = About;
  
  return About;
}






