/*
 * sensors.c
 *
 * Un processus par capteur
 * Les capteurs renvoyent 1 si le chemin est libre
 */

#include "graphic.h"

// test des capteurs
int 
Sensor_Left()
{
  switch(direction)
    {
    case TOWARD_DOWN:  if(map[current_position + 1]      != '1') return(1); break;
    case TOWARD_UP:    if(map[current_position - 1]      != '1') return(1); break;
    case TOWARD_LEFT:  if(map[current_position - NB_COL] != '1') return(1); break; 
    case TOWARD_RIGHT: if(map[current_position + NB_COL] != '1') return(1); break;
    }
  return(0);
}

/*int 
Sensor_Left()
{
  switch(direction)
    {
    case TOWARD_DOWN:  if(recupere(current_position + 1)      != '1') return(1); break;
    case TOWARD_UP:    if(recupere(current_position - 1)      != '1') return(1); break;
    case TOWARD_LEFT:  if(recupere(current_position - NB_COL) != '1') return(1); break; 
    case TOWARD_RIGHT: if(recupere(current_position + NB_COL) != '1') return(1); break;
    }
  return(0);
}*/

int 
Sensor_Right()
{
  switch(direction)
    {
    case TOWARD_DOWN:  if(map[current_position - 1]      != '1') return(1); break;
    case TOWARD_UP:    if(map[current_position + 1]      != '1') return(1); break;
    case TOWARD_LEFT:  if(map[current_position + NB_COL] != '1') return(1); break; 
    case TOWARD_RIGHT: if(map[current_position - NB_COL] != '1') return(1); break;
    }
  return(0);
}

/*int 
Sensor_Right()
{
  switch(direction)
    {
    case TOWARD_DOWN:  if(recupere(current_position - 1)          != '1') return(1); break;
    case TOWARD_UP:    if(recupere(current_position + 1)          != '1') return(1); break;
    case TOWARD_LEFT:  if(recupere(map[current_position + NB_COL) != '1') return(1); break; 
    case TOWARD_RIGHT: if(recupere(current_position - NB_COL)     != '1') return(1); break;
    }
  return(0);
}*/

int 
Sensor_Front()
{
  switch(direction)
    {
    case TOWARD_DOWN:  if(map[current_position + NB_COL] != '1') return(1); break;
    case TOWARD_UP:    if(map[current_position - NB_COL] != '1') return(1); break;
    case TOWARD_LEFT:  if(map[current_position + 1]      != '1') return(1); break; 
    case TOWARD_RIGHT: if(map[current_position - 1]      != '1') return(1); break;
    }
return(0);
}

/*int 
Sensor_Front()
{
  switch(direction)
    {
    case TOWARD_DOWN:  if(recupere(current_position + NB_COL) != '1') return(1); break;
    case TOWARD_UP:    if(recupere(current_position - NB_COL) != '1') return(1); break;
    case TOWARD_LEFT:  if(recupere(current_position + 1)      != '1') return(1); break; 
    case TOWARD_RIGHT: if(recupere(current_position - 1)      != '1') return(1); break;
    }
return(0);
}*/

// Dplacements
void 
Turn_Toward(int vers)
{
  switch(vers)
    {
    case LEFT:    direction -= 1; if(direction < 1) direction = 4; break;
    case RIGHT:   direction += 1; if(direction > 4) direction = 1; break;
    }
}

void Move_Forward()
{
  switch(direction)
    {
    case TOWARD_DOWN:  current_position += NB_COL; break;
    case TOWARD_UP:    current_position -= NB_COL; break;
    case TOWARD_LEFT:  current_position += 1;      break;
    case TOWARD_RIGHT: current_position -= 1;      break;
    }
}

/*void Move_Forward()
{
  switch(direction)
    {
    case TOWARD_DOWN:  envoi(current_position += NB_COL); break;
    case TOWARD_UP:    envoi(current_position -= NB_COL); break;
    case TOWARD_LEFT:  envoi(current_position += 1);      break;
    case TOWARD_RIGHT: envoi(current_position -= 1);      break;
    }
}*/

// fonction de scan des capteurs
int Scan_Sensors()
{
  int sensor_left, sensor_right, sensor_front;
  
  sensor_left  = Sensor_Left();
  sensor_right = Sensor_Right();
  sensor_front = Sensor_Front();
  
  if      (sensor_left   && !sensor_right && !sensor_front) return(LEFT);
  else if (sensor_left   && sensor_right  && !sensor_front) return(LEFT_RIGHT);
  else if (sensor_left   && !sensor_right && sensor_front)  return(LEFT_FRONT);
  else if (sensor_left   && sensor_right  && sensor_front)  return(LEFT_RIGHT_FRONT);
  else if (sensor_right  && !sensor_left  && !sensor_front) return(RIGHT);
  else if (sensor_right  && !sensor_left  && sensor_front)  return(RIGHT_FRONT);
  else if (!sensor_right && !sensor_left  && sensor_front)  return(FRONT);
  else
    return(T);
}

void Explorer_Algo()
{
  switch(Scan_Sensors())
    {
    case FRONT: 
      Move_Forward();
      break;
    case LEFT: 
      Turn_Toward(LEFT); 
      Move_Forward();
      break;
    case LEFT_RIGHT: 
      Turn_Toward(LEFT); 
      Move_Forward();
      break;
    case LEFT_FRONT: 
      Turn_Toward(LEFT); 
      Move_Forward();
      break;
    case LEFT_RIGHT_FRONT:  
      Turn_Toward(LEFT); 
      Move_Forward();
      break;
    case RIGHT: 
      Turn_Toward(RIGHT); 
      Move_Forward();
      break;
    case RIGHT_FRONT: 
      Move_Forward();
      break;
    case T: // demi-tour
      Turn_Toward(LEFT); 
      Turn_Toward(LEFT);
      break; 
    }
}


